package seminar;

import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class FormularServlet extends HttpServlet{
	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException{
			
		// Mime-Type fuer die Antwort setzen
		res.setContentType("text/html");
		
		// PrintWriter auf die Antwort aufsetzen
		PrintWriter out = res.getWriter();
		
		/** 
		 * holt eine HttpSession aus der Anfrage; true bedeutet hierbei, dass
		 * eine neue Session erzeugt wird, falls noch keine existiert 
		 */
		HttpSession session = req.getSession(true);
		
		/**
		 * Anfang der html-Seite ausgeben
		 */
		out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"");
		out.println("\"http://www.w3.org/TR/html4/transitional.dtd\">");
		out.println("   <html>");
		if(session.isNew()){// if-1
			/**
			 * Session wurde noch nicht vom Browser angenommen, also wird zunaechst
			 * ein Eingabeformular ausgegeben
			 */
			out.println("   <head>");
			out.println("	   <title>DatenFormular</title>");
			out.println("	   <link href=\"Style.css\" rel=\"stylesheet\" type=\"text/css\" >");
			out.println("	   <meta name=\"author\" content=\"Christina Eicher\">");
			out.println("	   <meta name=\"description\" content=\"Web-Site zum Servlet-Testen\">");
			out.println("	   <meta name=\"keywords\" content=\"Servlet\">");
			out.println("   </head>");
		
			out.println("	<body>");
			out.println("		 <br>");
			out.println("		 <h1> Daten-Formular </h1>");
			out.println("		 <br>");
			out.println("		 Bitte f&uuml;llen Sie die nachfolgenden Felder aus:");
			out.println("			<form method=\"get\" action=\"/seminar/datenservlet\">");
			out.println("			<table align=center>");
			out.println("			   <tr>");
			out.println("				 <td>  <input name=\"geschlecht\" type=radio value=\"maennlich\"> m&auml;nnlich");
			out.println("					   <input name=\"geschlecht\" type=radio value=\"weiblich\"> weiblich</td>");
			out.println("			   </tr>");
			out.println("			   <tr>");
			out.println("				 <td><input name=\"alter\" size=2 maxlength=3 type=int> &nbsp; Alter</td>");
			out.println("			   </tr>");
			out.println("			   <tr>");
			out.println("				 <td> <input name=\"name\" size=20> </td>");
			out.println("				 <td> Name </td>");
			out.println("			   </tr>");
			out.println("			   <tr>");
			out.println("				 <td><input name=\"vorname\" size=20> </td>");
			out.println("				 <td>Vorname</td>");
			out.println("			   </tr>");
			out.println("			   <tr>");
			out.println("				 <td><input name=\"strasse\" size=20> </td>");
			out.println("				 <td>Strae</td>");
			out.println("			   </tr>");
			out.println("			   <tr>");
			out.println("				 <td><input name=\"wohnort\" size=20> </td>");
			out.println("				 <td>Wohnort</td>");
			out.println("			   </tr>");
			out.println("			   <tr>");
			out.println("				 <td>&nbsp;<td>");
			out.println("			   </tr>");
			out.println("			   <tr>");
			out.println("				 <td><input type=reset value=\"lschen\">");
			out.println("					 <input type=submit value=\">> weiter\"></td>");
			out.println("			   </tr>");
			out.println("			</table>");
			out.println("			</form>");
		}// Ende if-1
		else{
			/**
			 * Session wurde vom Client schon akzeptiert
			 */
			/**
			 * Attribut userdaten holen;
			 * wenn es dieses Objekt noch nicht gibt, wird null zurueckgeliefert
			 */ 
			UserDaten userdaten = (UserDaten)session.getAttribute("userdaten");

			String name = null;
			String vorname = null;
			String strasse = null;
			String wohnort = null;
			String geschlecht = null;
			String alter = null;
			
			if (userdaten == null){// if-2
				try {// wegen dem Integer.parseInt
				/**
				 * Parameter aus dam Formular einlesen
				 */
				name = (String) req.getParameter("name");
				vorname = (String) req.getParameter("vorname");
				strasse = (String) req.getParameter("strasse");
				wohnort = (String) req.getParameter("wohnort");
				geschlecht = (String)req.getParameter("geschlecht");
				
				/**
				 * Bei der Altersangabe wird zustzlich berprft, ob
				 * es sich um eine positive Zahl handelt.
				 */
				int a = -1;
				try {
					a = Integer.parseInt(req.getParameter("alter"));
				} catch (NumberFormatException e1) {
					System.out.println(e1);
				}
				if(a < 0){
					alter = null;
				}
				else{
					alter = a + "";
				}
				
				/** 
				 * nun wird generell geprft, ob alle Felder ausgefllt wurden
				 */
				if(	  name==null
					||vorname==null
					||strasse==null
					||wohnort==null
					||alter==null
					||geschlecht==null
					) 
					throw new LeeresFeldException();
				
				/**
				 * neues UserDaten-Objekt erstellen
				 */
				userdaten = new UserDaten(name, vorname, strasse, wohnort, alter, geschlecht);
				
				/**
				 * erzeugtes Objekt einfuegen
				 */
				session.setAttribute("userdaten", userdaten);
				
				/**
				 * Nachdem nun das UserDaten-Objekt existiert, kann die
				 * Bewertung mithilfe des Bewertungsbogens erfolgen:
				 */
				
				out.println("<head>");
				out.println("	<title>BewertungsBogen</title>");
				out.println("	<link href=\"Style.css\" rel=\"stylesheet\" type=\"text/css\" >");
				out.println("	<meta name=\"author\" content=\"Christina Eicher\">");
				out.println("	<meta name=\"description\" content=\"Web-Site zum Servlet-Testen\">");
				out.println("	<meta name=\"keywords\" content=\"Servlet\">");
				out.println("</head>");

				out.println("<body>");
				out.println(" <br>");
				out.println(" <h1> Bewertungs-Bogen </h1>");
				out.println(" <br>");
				out.println(" Bitte bewerten Sie folgende Exponate mit einer Punktzahl von 0-5:");
				out.println(" <form method=\"get\" action=\"/seminar/datenservlet\">");
				out.println(" <table align=center>");
				out.println("	<tr>");
				out.println("	  <td align=center>  </td>");
				out.println("	  <td align=center> 0</td>");
				out.println("	  <td align=center> 1</td>");
				out.println("	  <td align=center> 2</td>");
				out.println("	  <td align=center> 3</td>");
				out.println("	  <td align=center> 4</td>");
				out.println("	  <td align=center> 5</td>");
				out.println("	<tr>");
				out.println("	  <td>Exponat 1 &nbsp;</td>");
				out.println("	  <td><input name=\"exp1\" type=radio value=\"0\" checked></td>");
				out.println("	  <td><input name=\"exp1\" type=radio value=\"1\"></td>");
				out.println("	  <td><input name=\"exp1\" type=radio value=\"2\"></td>");
				out.println("	  <td><input name=\"exp1\" type=radio value=\"3\"></td>");
				out.println("	  <td><input name=\"exp1\" type=radio value=\"4\"></td>");
				out.println("	  <td><input name=\"exp1\" type=radio value=\"5\"></td>");
				out.println("	</tr>");
				out.println("	<tr>");
				out.println("	  <td>Exponat 2 &nbsp;</td>");
				out.println("	  <td><input name=\"exp2\" type=radio value=\"0\" checked></td>");
				out.println("	  <td><input name=\"exp2\" type=radio value=\"1\"></td>");
				out.println("	  <td><input name=\"exp2\" type=radio value=\"2\"></td>");
				out.println("	  <td><input name=\"exp2\" type=radio value=\"3\"></td>");
				out.println("	  <td><input name=\"exp2\" type=radio value=\"4\"></td>");
				out.println("	  <td><input name=\"exp2\" type=radio value=\"5\"></td>");
				out.println("	</tr>");
				out.println("	<tr>");
				out.println("	  <td>Exponat 3 &nbsp;</td>");
				out.println("	  <td><input name=\"exp3\" type=radio value=\"0\" checked></td>");
				out.println("	  <td><input name=\"exp3\" type=radio value=\"1\"></td>");
				out.println("	  <td><input name=\"exp3\" type=radio value=\"2\"></td>");
				out.println("	  <td><input name=\"exp3\" type=radio value=\"3\"></td>");
				out.println("	  <td><input name=\"exp3\" type=radio value=\"4\"></td>");
				out.println("	  <td><input name=\"exp3\" type=radio value=\"5\"></td>");
				out.println("	</tr>");
				out.println("	<tr>");
				out.println("	  <td>Exponat 4 &nbsp;</td>");
				out.println("	  <td><input name=\"exp4\" type=radio value=\"0\" checked></td>");
				out.println("	  <td><input name=\"exp4\" type=radio value=\"1\"></td>");
				out.println("	  <td><input name=\"exp4\" type=radio value=\"2\"></td>");
				out.println("	  <td><input name=\"exp4\" type=radio value=\"3\"></td>");
				out.println("	  <td><input name=\"exp4\" type=radio value=\"4\"></td>");
				out.println("	  <td><input name=\"exp4\" type=radio value=\"5\"></td>");
				out.println("	</tr>");
				out.println("	<tr>");
				out.println("	  <td>Exponat 5 &nbsp;</td>");
				out.println("	  <td><input name=\"exp5\" type=radio value=\"0\" checked></td>");
				out.println("	  <td><input name=\"exp5\" type=radio value=\"1\"></td>");
				out.println("	  <td><input name=\"exp5\" type=radio value=\"2\"></td>");
				out.println("	  <td><input name=\"exp5\" type=radio value=\"3\"></td>");
				out.println("	  <td><input name=\"exp5\" type=radio value=\"4\"></td>");
				out.println("	  <td><input name=\"exp5\" type=radio value=\"5\"></td>");
				out.println("	</tr>");
				out.println("	<tr>");
				out.println("	  <td>Exponat 6 &nbsp;</td>");
				out.println("	  <td><input name=\"exp6\" type=radio value=\"0\" checked></td>");
				out.println("	  <td><input name=\"exp6\" type=radio value=\"1\"></td>");
				out.println("	  <td><input name=\"exp6\" type=radio value=\"2\"></td>");
				out.println("	  <td><input name=\"exp6\" type=radio value=\"3\"></td>");
				out.println("	  <td><input name=\"exp6\" type=radio value=\"4\"></td>");
				out.println("	  <td><input name=\"exp6\" type=radio value=\"5\"></td>");
				out.println("	</tr>");
				out.println("	<tr>");
				out.println("	  <td>");
				out.println("	  <br>");
				out.println("		  <input type=submit value=\"abschicken\">");
				out.println("	  </td>");
				out.println("	</tr>");

				out.println(" </table>");
				out.println(" <br>");
				out.println(" <br>");
				out.println(" <table align=center>");
				out.println("   <tr>");
				out.println("	 <td>");
				out.println("	   <small>0 ="); 
				out.println("	 </td>");
				out.println("	 <td>");
				out.println("	   <small>gef&auml;llt mir gar nicht");
				out.println("	 </td>");
				out.println("   </tr>");
				out.println("   <tr>");
				out.println("	 <td>");
				out.println("	   <small>1 ="); 
				out.println("	 </td>");
				out.println("	 <td>");
				out.println("	   <small>gef&auml;llt mir nicht so gut");
				out.println("	 </td>");
				out.println("   </tr>");
				out.println("   <tr>");
				out.println("	 <td>");
				out.println("	   <small>2 ="); 
				out.println("	 </td>");
				out.println("	 <td>");
				out.println("	   <small>k&ouml;nnte besser sein");
				out.println("	 </td>");
				out.println("   </tr>");
				out.println("  <tr>");
				out.println("	 <td>");
				out.println("	   <small>3 ="); 
				out.println("	 </td>");
				out.println("	 <td>");
				out.println("	   <small>gef&auml;llt mir mittelm&auml;&szlig;ig");
				out.println("	 </td>");
				out.println("   </tr>");
				out.println("   <tr>");
				out.println("	 <td>");
				out.println("	   <small>4 ="); 
				out.println("	 </td>");
				out.println("	 <td>");
				out.println("	   <small>gef&auml;llt mir gut");
				out.println("	 </td>");
				out.println("  </tr>");
				out.println("  <tr>");
				out.println("	 <td>");
				out.println("	   <small>5 ="); 
				out.println("	 </td>");
				out.println("	 <td>");
				out.println("	   <small>gef&auml;llt mir sehr gut");
				out.println("	 </td>");
				out.println("  </tr>");
				out.println("</table>");
				out.println("</form>");	
				} catch (LeeresFeldException e) {
					/**
					 * bei falscher Eingabe des Alters, gibt's ein neues Formular mit Fehlermeldung
					 */
					out.println("   <head>");
					out.println("	   <title>DatenFormular</title>");
					out.println("	   <link href=\"Style.css\" rel=\"stylesheet\" type=\"text/css\" >");
					out.println("	   <meta name=\"author\" content=\"Christina Eicher\">");
					out.println("	   <meta name=\"description\" content=\"Web-Site zum Servlet-Testen\">");
					out.println("	   <meta name=\"keywords\" content=\"Servlet\">");
					out.println("   </head>");
		
					out.println("	<body>");
					out.println("		 <br>");
					out.println("		 <h1> Daten-Formular </h1>");	
					out.println("		 <br>");				
					out.println("		 <br>");
					out.println("		 <p><big>Die Angaben waren entweder nicht richtig, oder nicht vollst&auml;ndig. Bei Alter muss eine Zahl eingegeben werden!! Try again...</big></p>");
					out.println("		 <br>");
					out.println("			<form method=\"get\" action=\"/seminar/datenservlet\">");
					out.println("			<table align=center>");
					out.println("			   <tr>");
					if(geschlecht==null){
						out.println("				 <td>  <input name=\"geschlecht\" type=radio value=\"maennlich\"> m&auml;nnlich");
						out.println("					   <input name=\"geschlecht\" type=radio value=\"weiblich\"> weiblich</td>");
					}else{
						System.out.println("1");
						if(geschlecht.equals("maennlich")){
							System.out.println("2");
							out.println("				 <td>  <input name=\"geschlecht\" type=radio value=\"maennlich\" checked> m&auml;nnlich");
							out.println("					   <input name=\"geschlecht\" type=radio value=\"weiblich\"> weiblich</td>");
							System.out.println("3");
						}
						if(geschlecht.equals("weiblich")){
							System.out.println("4");
							out.println("				 <td>  <input name=\"geschlecht\" type=radio value=\"maennlich\"> m&auml;nnlich");
							out.println("					   <input name=\"geschlecht\" type=radio value=\"weiblich\" checked> weiblich</td>");
						
							System.out.println("5");}
						System.out.println("6");
					}
					out.println("			   </tr>");
					out.println("			   <tr>");
					if(alter==null){
					out.println("				 <td><input name=\"alter\" size=2 maxlength=3 type=int> &nbsp; Alter</td>");
					}else{
						out.println("				 <td><input name=\"alter\" size=2 maxlength=3 type=int value = \"" + alter + "\"> &nbsp; Alter</td>");
					}
					out.println("			   </tr>");
					out.println("			   <tr>");
					if(name==null){
					out.println("				 <td> <input name=\"name\" size=20> </td>");
					}else{
					out.println("				 <td> <input name=\"name\" size=20 value = \"" + name + "\"> </td>");
					}
					out.println("				 <td> Name </td>");
					out.println("			   </tr>");
					out.println("			   <tr>");
					if(vorname==null){
					out.println("				 <td> <input name=\"vorname\" size=20> </td>");
					}else{
					out.println("				 <td> <input name=\"vorname\" size=20 value = \"" + vorname + "\"> </td>");
					}
					out.println("				 <td>Vorname</td>");
					out.println("			   </tr>");
					out.println("			   <tr>");
					if(strasse==null){
					out.println("				 <td><input name=\"strasse\" size=20> </td>");
					}else{
					out.println("				 <td><input name=\"strasse\" size=20 value = \"" + strasse + "\"> </td>");
					}
					out.println("				 <td>Strae</td>");
					out.println("			   </tr>");
					out.println("			   <tr>");
					if(wohnort==null){
					out.println("				 <td><input name=\"wohnort\" size=20> </td>");
					}else{
					out.println("				 <td><input name=\"wohnort\" size=20 value = \"" + wohnort + "\"> </td>");
					}
					out.println("				 <td>Wohnort</td>");
					out.println("			   </tr>");
					out.println("			   <tr>");
					out.println("				 <td>&nbsp;<td>");
					out.println("			   </tr>");
					out.println("			   <tr>");
					out.println("				 <td><input type=reset value=\"lschen\">");
					out.println("					 <input type=submit value=\">> weiter\"></td>");
					out.println("			   </tr>");
					out.println("			</table>");
					out.println("			</form>");
				}// Ende catch	
			}// Ende if-2
			else{
				/**
				 * nun muss der ausgefllte Bewertungsbogen verarbeitet werden
				 */
				userdaten.setProduktbewertung(new Produktbewertung(	Integer.parseInt((String) req.getParameter("exp1")),
																	Integer.parseInt((String) req.getParameter("exp2")),
																	Integer.parseInt((String) req.getParameter("exp3")),
																	Integer.parseInt((String) req.getParameter("exp4")),
																	Integer.parseInt((String) req.getParameter("exp5")),
																	Integer.parseInt((String) req.getParameter("exp6"))));
				
				try {
					userdaten.save();
					session.invalidate(); //Beenden der Session
				} catch (Exception e) {
					e.printStackTrace();
				}
				
				out.println("   <head>");
				out.println("	   <title>AuswertungAnzeigen</title>");
				out.println("	   <link href=\"Style.css\" rel=\"stylesheet\" type=\"text/css\" >");
				out.println("	   <meta name=\"author\" content=\"Christina Eicher\">");
				out.println("	   <meta name=\"description\" content=\"Web-Site zum Servlet-Testen\">");
				out.println("	   <meta name=\"keywords\" content=\"Servlet\">");
				out.println("   </head>");
		
				out.println("	<body>");
				out.println("		 <br>");	
				out.println("		 <br>");
				out.println("		 <br>");
				out.println("		 <br>");
				out.println("		 <br>");
				out.println("		 <br>");
				out.println("		 <br>");				
				out.println("		 <a href = \"http://localhost:8080/seminar/auswertungsservlet\"> >> Auswertung anzeigen</a>");
				out.println("		 <br>");
			
			}// Ende else-2
		}//Ende else-1
		/**
		 * html-Seite beenden
		 */ 
		out.println("</body>");
		out.println("</html>");
	} //Ende doGet
}