<!-- edited with XML Spy v4.3 U (http://www.xmlspy.com) by a (a) -->
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<xsl:variable name="lower" select="abcdefghijklmnopqrstuvwxyz"/>
	<xsl:variable name="upper" select="ABCDEFGHIJKLMNOPQRSTUVWXYZ"/>
	<xsl:variable name="crlf" select="'&#xA;'"/>
	<xsl:variable name="quot">"</xsl:variable>
	<xsl:variable name="squot">'</xsl:variable>
	<xsl:variable name="lt"><![CDATA[<]]></xsl:variable>
	<xsl:variable name="gt"><![CDATA[>]]></xsl:variable>
	<xsl:template match="/"/>
	<!--
	puts the first character of an identifier into lower case
	
	Example:	MyNiceThing -> myNiceThing
-->
	<xsl:template name="createMemberId">
		<xsl:param name="name"/>
		<xsl:call-template name="toLower">
			<xsl:with-param name="str" select="substring($name,1,1)"/>
		</xsl:call-template>
		<xsl:value-of select="substring($name,2,1000)"/>
	</xsl:template>
	<!--
		puts the first character of an identifier into upper case
		
		Example: myNiceThing -> MyNiceThing
-->
	<xsl:template name="createAbstractId">
		<xsl:param name="name"/>
		<xsl:call-template name="toUpper">
			<xsl:with-param name="str" select="substring($name,1,1)"/>
		</xsl:call-template>
		<xsl:value-of select="substring($name,2,1000)"/>
	</xsl:template>
	<!--
		puts all alphabetical characters of a string into upper case
		
		Example: a_sdf9 -> A_SDF	9
-->
	<xsl:template name="toUpper">
		<xsl:param name="str"/>
		<xsl:value-of select="translate($str,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
	</xsl:template>
	<!--
		puts all alphabetical characters of a string into lower case
		
		Example: A_sDF9 -> a_sdf9 	
-->
	<xsl:template name="toLower">
		<xsl:param name="str"/>
		<xsl:value-of select="translate($str,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
	</xsl:template>
	<!--
		creates the portal framework standard data types for fields
		
		precondition:	look at the select values -> we need to find such nodes in the current scope!
	
-->
	<xsl:template name="createTypeId">
		<xsl:for-each select="string">String</xsl:for-each>
		<xsl:for-each select="integer">Integer</xsl:for-each>
		<xsl:for-each select="double">Double</xsl:for-each>
		<xsl:for-each select="date">Date</xsl:for-each>
	</xsl:template>
	<xsl:template name="createSQLId">
		<xsl:param name="name"/>
		<xsl:call-template name="toUpper">
			<xsl:with-param name="str" select="substring($name,1,1)"/>
		</xsl:call-template>
		<xsl:call-template name="createRemainingSQLId">
			<xsl:with-param name="str" select="substring($name,2,1000)"/>
		</xsl:call-template>
	</xsl:template>
	<xsl:template name="createRemainingSQLId">
		<xsl:param name="str"/>
		<xsl:if test="$str!=''">
			<xsl:variable name="char" select="substring($str,1,1)"/>
			<xsl:variable name="remaining" select="substring($str,2,1000)"/>
			<xsl:variable name="converted">
				<xsl:call-template name="toUpper">
					<xsl:with-param name="str" select="$char"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="$converted=$char">
				<xsl:value-of select="'_'"/>
			</xsl:if>
			<xsl:value-of select="$converted"/>
			<xsl:call-template name="createRemainingSQLId">
				<xsl:with-param name="str" select="$remaining"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>


</xsl:stylesheet>
